#include <iostream>

using namespace std;

int funkcija(int a[], int k, int l, int d){
	if(k==0){
		int sum=0;
		for(int i=l; i<=d; i++){
			sum+=a[i];
		}
		return sum%1000000007;
	}
	
	int rez=0;
	for(int i=l; i<=d; i++){
		for(int j=i; j<=d; j++){
			rez=(rez+funkcija(a, k-1, i, j))%1000000007;
		}
	}
	return rez;
	
}

int main() {
	int n, k;
	cin>>n>>k;
	int a[n];
	for(int i=0; i<n; i++){
		cin>>a[i];
	}
	cout<<funkcija(a, k, 0, n-1);
	return 0;
}